unit Main;

(*
    Protokoly 2.4
    Copyright (C) 2002  Ing. David Motl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Grids, Buttons, ExtCtrls, XMLStream, About, Math, ToolWin,
  ImgList, Preview, Utils, JulDat, TypClass, TypVis, TypCCD, Konfig, Spin,
  Katalog, KatDlg;

type
  TMainForm = class(TForm)
    Pages: TPageControl;
    FileSheet: TTabSheet;
    HeadSheet: TTabSheet;
    GridSheet: TTabSheet;
    ImgSheet: TTabSheet;
    FootSheet: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Pozorovatel: TComboBox;
    Bydliste: TComboBox;
    Stanoviste: TComboBox;
    Pristroj: TComboBox;
    Label7: TLabel;
    Podminky: TComboBox;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Label9: TLabel;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Pocet: TEdit;
    Label15: TLabel;
    Sestupnych: TEdit;
    CompSheet: TTabSheet;
    Comps: TStringGrid;
    Label10: TLabel;
    NewBtn: TBitBtn;
    OpenBtn: TBitBtn;
    SaveBtn: TBitBtn;
    SaveAsBtn: TBitBtn;
    KonecBtn: TBitBtn;
    AboutBtn: TBitBtn;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    Grid: TStringGrid;
    ImageList: TImageList;
    Graph: TPaintBox;
    MAPKA: TComboBox;
    PrintBtn: TBitBtn;
    Label8: TLabel;
    Zvetseni: TComboBox;
    PrintDlg: TPrintDialog;
    Datum: TDateTimePicker;
    ToolBar: TToolBar;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Kamera: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    Filtr: TComboBox;
    ToolButton8: TToolButton;
    ImportDlg: TOpenDialog;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ExportDlg: TSaveDialog;
    ToolButton13: TToolButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Label1: TLabel;
    Katalog: TGroupBox;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    LoadKat: TBitBtn;
    Min: TEdit;
    PER: TEdit;
    SaveKat: TBitBtn;
    DelKat: TBitBtn;
    Hvezda: TEdit;
    RA: TEdit;
    DEC: TEdit;
    Label13: TLabel;
    MinDT: TEdit;
    MinJDGeo: TEdit;
    JDLabel: TLabel;
    Label19: TLabel;
    MinHelKor: TEdit;
    Label20: TLabel;
    MinJDhel: TEdit;
    Label21: TLabel;
    Label22: TLabel;
    ToolButton12: TToolButton;
    Button1: TButton;
    ToolButton14: TToolButton;
    HelpBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure SaveAsBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure ContChange(Sender: TObject);
    procedure PagesChange(Sender: TObject);
    procedure GridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure GridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure ToolButton4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PrintBtnClick(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure GridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure DatumChange(Sender: TObject);
    procedure GraphPaint(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    procedure SaveKatClick(Sender: TObject);
    procedure GridEnter(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure CompsSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FootSheetEnter(Sender: TObject);
    procedure GraphMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GraphMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GraphMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LoadKatClick(Sender: TObject);
    procedure DelKatClick(Sender: TObject);
    procedure HvezdaChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton14Click(Sender: TObject);
    procedure CompsSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HelpBtnClick(Sender: TObject);
  public
    FileName  :String;                { Jmeno prave otevreneho souboru }
    FForm     :TFormular;             { Trida, ktera definuje chovani aplikace (typ formulare) }
    Changed  :boolean;                { TRUE, pokud se neco zmenilo a neni to ulozene }
    IsUpdating:boolean;               { TRUE, pokud se prave neco meni }
    ChartRect :TRect;                 { Vyrez mapky }
    MouseMode :integer;               { Rezim mysi }
    MouseX,MouseY:integer;            { Pozice, na ktere byla stisknuta mys }
    OrigTMin  :double;                { Originalni TMinima, kdyz se stiskla mys }
    JDMin     :double;                { Okamzik minima }
    HelKor    :double;                { Korekce }
    JDHel     :double;                { Helioc. okamzik minima }
    WasEnter  :boolean;
    { Cteni / zapis souboru s projektem }
    Function  GenFileName:String;
    Procedure LoadProject(AFileName:String);
    Procedure SaveProject(AFileName:String);
    Procedure DataStartTag(ASender:TXMLParser; AnElement:String; S:TStrings);
    { Chovani programu }
    Procedure UpdateParams;
    Procedure UpdateMin;
              { Aktualizace rozhrani }
    Function  TestChanged:boolean;
              { Pokud se neco zmenilo, nabidne ulozeni projektu }
    Function  CompRows(i,j:integer):boolean;
              { Pro razeni: vraci TRUE, kdyz radek i je mensi nez j }
    Procedure SwapRows(i,j:integer);
              { Pro razeni: vymeni radky i a j }
    { Konverzni utilitky }
    Function  GetRA:double;
    Function  GetDEC:double;
    Function  GetM0:double;
    Function  GetPER:double;
    { Elektronicka napoveda }
    function  NasHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
              { Spousti napovedu }
    procedure WMHelp(var Message: TWMHelp); message WM_HELP;
              { Odchytava stisk F1 v oknech - ta musi mit povolena v BorderIcons volba biHelp ! }
  end;

var
  MainForm: TMainForm;

implementation

uses Select, Enter;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
 { Inicializace }
 Pages.ActivePage:=FileSheet;
 Application.OnHelp:=NasHelp;
 DecimalSeparator:=',';
 MouseMode:=0;
 Changed:=false;
 Datum.Date:=Now-1;
 IsUpdating:=true;
 Konf.KonfigFileName:=ExtractFilePath(Application.EXEName)+KonfigSoubor;
 OpenDlg.InitialDir:=ExtractFileDir(Application.EXEName);
 SaveDlg.InitialDir:=OpenDlg.InitialDir;
 ImportDlg.InitialDir:=OpenDlg.InitialDir;
 ExportDlg.InitialDir:=OpenDlg.InitialDir;
 { Nacteni konfigurace }
 Konf.LoadKonfig;
 Kat:=TKatalog.Create(ExtractFileDir(Application.EXEName));
 { Vytvorit novy protokol stejneho typu jako posledni protokol }
 { Nahrat projekt, pokud je predan parametr }
 if (paramcount>0) and FileExists(paramstr(1)) then
   LoadProject(paramstr(1))
 else begin
   { Novy projekt stejneho typu jako posledni protokol }
   if Konf.LastTyp=dvTypCCD then begin
     FForm:=TFormularCCD.Create;
     Konf.LastTyp:=dvTypCCD;
   end else begin
     FForm:=TFormularVis.Create;
     Konf.LastTyp:=dvTypVis;
   end;
 end;
 { Aktualizuj uzivatelske rozhrani }
 IsUpdating:=false;
 Changed:=false;
 UpdateParams;
end;

procedure TMainForm.OpenBtnClick(Sender: TObject);
{ Otevre projekt }
begin
 if TestChanged then begin
   OpenDlg.InitialDir:=Konf.DataPath;
   OpenDlg.FileName:='';
   if OpenDlg.Execute then begin
     Konf.DataPath:=ExtractFileDir(OpenDlg.FileName);
     Konf.SaveKonfig;
     if Assigned(FForm) then FForm.ClearData;
     { Nacteni projektu }
     LoadProject(OpenDlg.FileName);
     FileName:=OpenDlg.FileName;
     Changed:=false;
     { Nastaveni rozhrani }
     UpdateParams;
   end;
 end;
end;

Procedure TMainForm.DataStartTag;
{ Zpracovani tagu pri cteni proejktu }
var Str:String;
begin
 if AnElement=dkProjektTag then begin
   { Projekt }
   Str:=XMLString(S,dkTyp,'');
   { Podle typu projektu se vytvori objekt spravne tridy }
   if Str=dvTypCCD then FForm:=TFormularCCD.Create
                   else FForm:=TFormularVis.Create;
   { Volani parseru se presmeruje do vytvoreneho objektu }
   if Assigned(FForm) then begin
     ASender.OnStartTag:=FForm.DataStartTag;
     ASender.OnPCData  :=FForm.DataPCData;
   end;
 end;
end;

Procedure TMainForm.LoadProject;
{ Nacteni projektu ve formatu XML }
var P:TXMLParser;
begin
 Changed:=false;
 IsUpdating:=true;
 Screen.Cursor:=crHourGlass;
 try
   P:=TXMLParser.Create(TFileStream.Create(AFileName,fmOpenRead));
   try
     P.OnStartTag:=DataStartTag;
     P.Parse;
   finally
     P.Free;
   end;
 finally
   Screen.Cursor:=crDefault;
   IsUpdating:=false;
 end;
 if Assigned(FForm) then FForm.RefreshData;
end;

Procedure TMainForm.SaveProject;
{ Ulozeni projektu do souboru }
var F:TStream;
begin
 Konf.UpdateHistory;
 if Assigned(FForm) then begin
   F:=TFileStream.Create(AFileName,fmCreate);
   Screen.Cursor:=crHourGlass;
   try
     FForm.SaveData(F);
     Changed:=false;
   finally
     Screen.Cursor:=crDefault;
     F.Free;
   end;
 end;
end;

Procedure TMainForm.UpdateParams;
{ Aktualizace titulku okna }
begin
 if not IsUpdating then try
   IsUpdating:=true;
   Caption:='Protokoly ['+Hvezda.Text+']';
   Label11.Visible:=Kamera.Visible;
   Label12.Visible:=Filtr.Visible;
   Label8.Visible :=Zvetseni.Visible;
   Label10.Visible:=Mapka.Visible;
   if Assigned(FForm) then FForm.UpdatePocet;
   UpdateMin;
 finally
   IsUpdating:=false;
 end;  
end;

procedure TMainForm.NewBtnClick(Sender: TObject);
{ Novy projekt }
var FTyp:integer; 
begin
 if TestChanged then begin
   if FForm is TFormularCCD then FTyp:=1 else FTyp:=0;
   if SelectForm(FTyp) then begin
     Screen.Cursor:=crHourGlass;
     try
       FreeAndNil(FForm);
       if FTyp=0 then begin
         FForm:=TFormularVis.Create;
         Konf.LastTyp:=dvTypVis;
       end else
       if FTyp=1 then begin
         FForm:=TFormularCCD.Create;
         Konf.LastTyp:=dvTypCCD;
       end;
       Changed:=false;
       UpdateParams;
     finally
       Pages.ActivePage:=HeadSheet;
       Hvezda.SetFocus;
       Screen.Cursor:=crDefault;
     end;
   end;
 end;
end;

procedure TMainForm.SaveBtnClick(Sender: TObject);
{ Uloz projekt }
begin
 Konf.SaveKonfig;
 if FileName<>'' then
   SaveProject(FileName)
 else
   SaveAsBtnClick(Sender);
end;

procedure TMainForm.SaveAsBtnClick(Sender: TObject);
{ Uloz projekt do jineho souboru }
var Res:TModalResult;
begin
 SaveDlg.InitialDir:=Konf.DataPath;
 SaveDlg.FileName:=GenFileName;
 if SaveDlg.Execute then begin
   Konf.DataPath:=ExtractFileDir(SaveDlg.FileName);
   Konf.SaveKonfig;
   if FileExists(SaveDlg.FileName) then
     res:=MessageDlg('Soubor '+SaveDlg.FileName+' ji existuje. Chcete je pepsat ?',mtConfirmation,[mbYes,mbNo],0)
   else
     res:=mrYes;
   if res<>mrNo then begin
     SaveProject(SaveDlg.FileName);
     FileName:=SaveDlg.FileName;
   end;
 end;
end;

procedure TMainForm.AboutBtnClick(Sender: TObject);
{ O programu ... }
begin
 AboutBox.ShowModal;
end;

procedure TMainForm.ContChange(Sender: TObject);
{ Kdyz se cokoliv zmeni }
begin
 if not IsUpdating then begin
   UpdateParams;
   Changed:=TRUE;
 end;
end;

procedure TMainForm.PagesChange(Sender: TObject);
{ Kdyz se prejde na jinou stranku }
begin
 if Pages.ActivePage=HeadSheet then Hvezda.SetFocus else
 if Pages.ActivePage=GridSheet then Grid.SetFocus else
 if Pages.ActivePage=CompSheet then Comps.SetFocus;
end;

procedure TMainForm.GridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
{ Kdyz se klikne v Grid }
begin
 if (not IsUpdating) and Assigned(FForm) then FForm.UpdateGrid(ACol,ARow);
end;

procedure TMainForm.GridSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
{ Uzivatel neco zmenil v Grids - az dopise, bude se to muset zaktualizovat }
begin
 if Assigned(FForm) and (not IsUpdating) and (not Grid.EditorMode) then begin
   IsUpdating:=true;
   FForm.RefreshRow(ARow);
   if WasEnter then FForm.GotoNext;
   Changed:=true;
   IsUpdating:=false;
 end;
end;

procedure TMainForm.ToolButton4Click(Sender: TObject);
{ Zmena casu minima pomoci tlacitek o 1 nebo 10 minut dopredu nebo zpet }
var T:integer;
begin
 T:=round(frac(JDMin)*1440);
 if Sender=ToolButton1 then T:=T-10;
 if Sender=ToolButton2 then T:=T-1;
 if Sender=ToolButton3 then T:=T+1;
 if Sender=ToolButton4 then T:=T+10;
 JDMin:=int(JDMin)+frac(T/1440);
 FForm.UpdatePocet;
 UpdateMin;
 Changed:=true;
 Graph.Invalidate;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
{ Pri zavreni programu se ulozi Konfigurace }
begin
 Konf.SaveKonfig;
end;

procedure TMainForm.PrintBtnClick(Sender: TObject);
{ Tisk protokolu a grafu }
begin
 if TestChanged then begin 
   Nahled(FForm);
 end;
end;

procedure TMainForm.ToolButton5Click(Sender: TObject);
{ Vlozit do tabulky prazdy radek }
var i,j:integer;
begin
 with Grid do begin
   RowCount:=RowCount+1;
   Cells[0,RowCount-1]:=IntToStr(RowCount-1);
   { Presune hodnoty nasledujicich radku mimo sloupec Cisla }
   for i:=RowCount-2 downto Row do
     for j:=1 to ColCount-1 do Cells[j,i+1]:=Cells[j,i];
   for j:=1 to ColCount-1 do Cells[j,Row]:='';
 end;
 FForm.UpdateGrid(Grid.Col,Grid.Row);
 Changed:=true;
end;

procedure TMainForm.ToolButton6Click(Sender: TObject);
{ Vymaze z tabulky oznaceny radek }
var i,j:integer;
begin
 with Grid do begin
   if RowCount>2 then begin
     { Presune hodnoty nasledujicich radku mimo sloupec Cisla }
     for i:=Row+1 to RowCount-1 do
       for j:=1 to ColCount-1 do Cells[j,i-1]:=Cells[j,i];
     for j:=1 to ColCount-1 do Cells[j,RowCount-1]:='';
     RowCount:=RowCount-1;
   end else begin
     for i:=1 to ColCount-1 do Cells[i,1]:='';
   end;
 end;
 FForm.UpdateGrid(Grid.Col,Grid.Row);
 Changed:=true;
end;

Function TMainForm.CompRows;
{ Porovna dva radky podle casu. Prazdne radky se vzdy radi na konec }
var T1, T2:double; 
begin
 with Grid do begin
   if not FForm.GetTime(i, T1) then Result:=false else
   if not FForm.GetTime(j, T2) then Result:=true else
   Result:=T1<T2;
 end;
end;

Procedure TMainForm.SwapRows;
{ Vymeni hodnoty na dvou radcich }
var Aux:String; x:integer;
begin
 with Grid do begin
   { Vsechny sloupce krome Cisla }
   for x:=1 to ColCount-1 do begin
     Aux:=Cells[x,i];
     Cells[x,i]:=Cells[x,j];
     Cells[x,j]:=Aux;
   end;
 end;
end;

procedure TMainForm.ToolButton7Click(Sender: TObject);
{ Seradi radky odhadu podle casu }
begin
 QuickSort(1,Grid.RowCount-1,CompRows,SwapRows);
 FForm.UpdateGrid(Grid.Col,Grid.Col);
 Changed:=true;
end;

procedure TMainForm.GridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 { Vymazani bunky pri stisku DETELE }
 if (Key=VK_DELETE) and (Sender is TStringGrid) then begin
   with Sender as TStringGrid do Cells[Col,Row]:='';
   Changed:=true;
 end;
 WasEnter:=(Key=VK_RETURN);  
end;

procedure TMainForm.ToolButton8Click(Sender: TObject);
begin
 ImportDlg.InitialDir:=Konf.ImPath;
 ImportDlg.FileName:='';
 if ImportDlg.Execute then begin
   Konf.ImPath:=ExtractFileDir(ImportDlg.FileName);
   Konf.SaveKonfig;
   { Nacteni dat z formatu Munidos }
   FForm.ImportData(ImportDlg.FileName);
   QuickSort(1,Grid.RowCount-1,CompRows,SwapRows);
   FForm.RefreshData;
   { Nastaveni rozhrani }
   Changed:=true;
   UpdateParams;
   Grid.SetFocus;
 end;
end;

procedure TMainForm.ToolButton10Click(Sender: TObject);
var Str:String; dt,val:double;
begin
 Str:=FormatDateTime('hh:nn',JDToDateTime(JDMin));
 if EnterForm('Zadejte okamik minima v UT; mete vloit julinsk datum v desetinnm tvaru nebo as ve tvaru hh:mm (pklady: 2452123.4567, 52123.4567, 0.4567, 22:52)',Str) then begin
   Str:=CheckDec(Str);
   Val:=StrToFloatDef(Str,-1);
   if (Val>240000) then begin
     { Bylo zadano plne julianske datum }
     JDMin:=StrToFloat(Str);
   end else
   if (Val>50000)and(Val<2000000) then begin
     { Bylo zadano zkracene julianske datum }
     JDMin:=StrToFloat(Str)+2400000;
   end else
   if (Val>0)and(Val<1) then begin
     { Byla zadana desetinna cast julianskeho data }
     JDMin:=Val+int(datetimetojd(Datum.Date))+1;
   end else begin
     { Byl zadan obcansky cas }
     DT:=frac(StrToTime(Str));
     if DT>=0.5 then DT:=int(Datum.Date)+DT
                else DT:=int(Datum.Date+1)+DT;
     JDMin:=DateTimeToJD(DT);
   end;
   UpdateMin;
   Changed:=true;
   FForm.UpdatePocet;
   Graph.Invalidate;
 end;
end;

procedure TMainForm.DatumChange(Sender: TObject);
begin
 JDMin:=int(DateTimeToJD(Datum.Date+1))+frac(JDMin);
 UpdateMin;
end;

procedure TMainForm.GraphPaint(Sender: TObject);
begin
 if Assigned(FForm) then FForm.GraphPaint;
end;

procedure TMainForm.ToolButton12Click(Sender: TObject);
var S:String; i:integer;
begin
 S:=Lowercase(Hvezda.Text);
 i:=1;
 while (i<=Length(S)) do
   if not (S[i] in ['0'..'9','a'..'z']) or ((i=1)and(S[i]='v')) then Delete(S,i,1)
     else inc(i);
 ExportDlg.InitialDir:=Konf.ExPath;
 ExportDlg.FileName:=S;
 if ExportDlg.Execute then begin
   Konf.ExPath:=ExtractFileDir(ExportDlg.FileName);
   { Export dat ve formatu Tintagel }
   FForm.ExportData(ExportDlg.FilterIndex,ExportDlg.FileName);
   { Nastaveni rozhrani }
   UpdateParams;
   Grid.SetFocus;
 end;
end;

procedure TMainForm.SaveKatClick(Sender: TObject);
begin
 if Length(Hvezda.Text)=0 then
   raise Exception.Create('Vlote nzev hvzdy.');
 if Kat.SaveRec(Hvezda.Text,SetDec(RA.Text),SetDec(DEC.Text),SetDec(Min.Text),SetDec(Per.Text)) then
   MessageDlg('Zznam byl spn uloen do uivatelskho katalogu.',mtInformation,[mbOK],0)
 else
   MessageDlg('Uloen zznamu nebylo spn, pravdpodobn nen povolen zpis do adrese.',mtError,[mbOK],0);
end;

procedure TMainForm.DelKatClick(Sender: TObject);
begin
 if Length(Hvezda.Text)=0 then
   raise Exception.Create('Vlote nzev hvzdy.');
 if MessageDlg('Opravdu chcete vymazat z katalogu zznam o hvzd "'+Hvezda.Text+'" ?'#13#10+
               '(Mete vymazat pouze zznamy z uivatelskho katalogu.)',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
   if Kat.DelRec(Hvezda.Text) then
     MessageDlg('Zznam byl spn vymazn.',mtInformation,[mbOK],0)
   else
     MessageDlg('Vymazn nebylo spn, protoe takov zznam v uivatelskm katalogu neexistuje.',mtError,[mbOK],0);
 end;
end;

Function TMainForm.GetRA;
var S:String;
begin
 S:=CheckDec(RA.Text);
 Result:=StrToIntDef(copy(S,1,2),0)+
         StrToIntDef(copy(S,3,2),0)/60+
         StrToIntDef(copy(S,5,2),0)/3600;
end;

Function TMainForm.GetDEC;
var S:String;
begin
 S:=CheckDec(DEC.Text);
 Result:=StrToIntDef(copy(S,2,2),0)+
    StrToIntDef(copy(S,4,2),0)/60+
    StrToIntDef(copy(S,6,2),0)/3600;
 if copy(S,1,1)='-' then Result:=-Result;
end;

Function TMainForm.GetM0;
var Str:String;
begin
 Str:=CheckDec(Min.Text);
 Result:=StrToFloatDef(Str,0);
 if (Result>0)and(Result<2000000) then Result:=Result+2400000
end;

Function TMainForm.GetPER;
var Str:String;
begin
 Str:=CheckDec(Per.Text);
 Result:=StrToFloatDef(Str,0);
end;

procedure TMainForm.GridEnter(Sender: TObject);
begin
 FForm.RefreshData;
end;

procedure TMainForm.ToolButton13Click(Sender: TObject);
begin
 if Assigned(FForm) then FForm.RefreshData;
 Changed:=true;
end;

procedure TMainForm.CompsSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
 FForm.UpdateComp(ACol,ARow);
end;

procedure TMainForm.FootSheetEnter(Sender: TObject);
begin
 FForm.RefreshData;
end;

procedure TMainForm.GraphMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbLeft then begin
   MouseMode:=1;
   MouseX:=X;
   MouseY:=Y;
   OrigTMin:=JDMin;
   Screen.Cursor:=crSizeWE;
 end;
end;

procedure TMainForm.GraphMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbLeft then begin MouseMode:=0; Screen.Cursor:=crDefault; end;
end;

procedure TMainForm.GraphMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if MouseMode=1 then begin
   JDMin:=OrigTMin+(X-MouseX)/1440/4;
   UpdateMin;
   Graph.Invalidate;
 end;
end;

procedure TMainForm.LoadKatClick(Sender: TObject);
var Jmeno,R,D,M,P:String;
begin
 Jmeno:=Hvezda.Text;
 if LoadCatalog(Jmeno,R,D,M,P) then begin
   Hvezda.Text:=Jmeno;
   RA .Text:=CheckDec(R);
   DEC.Text:=CheckDec(D);
   Min.Text:=CheckDec(M);
   Per.Text:=CheckDec(P);
   FForm.RefreshData;
   UpdateMin;
   ContChange(NIL);
 end;
end;

procedure TMainForm.HvezdaChange(Sender: TObject);
begin
 Caption:='Protokoly ['+Hvezda.Text+']';
 ContChange(Sender);
end;

Procedure TMainForm.UpdateMin;
begin
 MinDT.Text:=FormatDateTime('d. m. yyyy hh:nn ',JDToDateTime(JDMin));
 MinJDGeo.Text:=Format('%.4f',[JDMin]);
 MinHelKor.Visible:=Katalog.Visible;   Label19.Visible:=MinHelKor.Visible;
 MinJDhel.Visible:=Katalog.Visible;    Label21.Visible:=MinJDHel.Visible;
 if Katalog.Visible then begin
   helkor:=HelCorr(MainForm.GetRA,MainForm.GetDEC,JDMin);
   jdhel:=JDMin+helkor;
   MinHelKor.Text:=Format('%.4f',[HelKor]);
   MinJDHel.Text:=Format('%.4f',[JDHel]);
   //Faze :=(jdhel-MainForm.GetM0)/MainForm.GetPER;
   //Ep   :=floor(Faze);
   //Faze :=Faze-Ep;
 end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
 if Assigned(FForm) then FForm.UpdateSestup;
 Changed:=true;
end;

procedure TMainForm.ToolButton14Click(Sender: TObject);
begin
 if MessageDlg('Opravdu chcete vymazat cel obsah tabulky?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
    if Assigned(FForm) then FForm.ClearGrid;
    Changed:=true;
 end;
end;

procedure TMainForm.CompsSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
 if (not IsUpdating) and (not Comps.EditorMode) then begin
   Changed:=true;
 end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=TestChanged;
end;

Function TMainForm.TestChanged;
var Res:TModalResult;
begin
 if Changed then begin
   Res:=MessageDlg('Pozor! Proveden zmny nebyly uloeny. Chcete protokol uloit do souboru?',mtWarning,[mbYes,mbNo,mbCancel],0);
   if Res=mrYes then begin
     Konf.SaveKonfig;
     if FileName<>'' then
       SaveProject(FileName)
     else begin
       SaveDlg.InitialDir:=Konf.DataPath;
       SaveDlg.FileName:=GenFileName;
       if SaveDlg.Execute then begin
         Konf.DataPath:=ExtractFileDir(SaveDlg.FileName);
         Konf.SaveKonfig;
         if FileExists(SaveDlg.FileName) then
           res:=MessageDlg('Soubor '+SaveDlg.FileName+' ji existuje. Chcete je pepsat ?',mtConfirmation,[mbYes,mbCancel],0)
         else
           res:=mrYes;
         if res=mrYes then begin
           SaveProject(SaveDlg.FileName);
           FileName:=SaveDlg.FileName;
         end;
       end;
     end;
   end;
   Result:=(Res<>mrCancel);
 end else
   Result:=true;
end;

Function TMainForm.GenFileName;
var i:word; S:String;
begin
 S:=Lowercase(Hvezda.Text)+'-'+FormatDateTime('yymmdd',Datum.Date);
 i:=1;
 while (i<=Length(S)) do
   if not (S[i] in ['0'..'9','a'..'z']) or ((i=1)and(S[i]='v')) then Delete(S,i,1)
     else inc(i);
 Result:=S;
end;

procedure TMainForm.HelpBtnClick(Sender: TObject);
begin
 ExecuteApp('hh.exe','protokoly.chm');
end;

procedure TMainForm.WMHelp(var Message: TWMHelp);
{ Toto je prevzaty kod z jednotky Forms. Musel jsem to predefinovat kvuli nove
  napovede aby fungovala na F1. Vsechna okna musi mit v BorderIcons
  povoleno biHelp }
begin
 with Message.HelpInfo^ do begin
   if iContextType = HELPINFO_WINDOW then
     if (Pages.ActivePage=GridSheet)and(FForm is TFormularCCD) then
       Application.HelpCommand(HELP_FINDER, 104)
     else if (Pages.ActivePage=GridSheet)and(FForm is TFormularVIS) then
       Application.HelpCommand(HELP_FINDER, 103)
     else
       Application.HelpCommand(HELP_FINDER, Pages.ActivePage.HelpContext);
 end;
end;

function TMainForm.NasHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
{Msto jakhokoliv PopUp helpu vyvol klasick velk okno s tmt kontextem.}
begin
 if (Command=8)or(Command=11) then begin
   ExecuteApp('hh.exe',Format('-mapid %d %s',[Data,'protokoly.chm']));
   CallHelp:=false; Result:=true;
 end else
   Result:=false;
end;


end.
