unit Utils;

(*
    Protokoly 2.4
    Copyright (C) 2002  Ing. David Motl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

interface

uses Windows, Classes, SysUtils, Controls, Math, juldat, ShellAPI;

type TCompareFunc = function(i,j: integer): boolean of object;
     TSwapFunc = procedure(i,j: integer) of object;

Function  StrToBoolDef(Data:String; ADef:boolean):boolean;
Function  BoolToStr(X:boolean):String;
Function  ifThen(C,A,B:boolean):boolean; overload;
Function  CheckDec(S:String):String;
Function  SetDec(S:String):String;
Function  DelWS(S:String):String;
procedure QuickSort(min,max: integer; Compare: TCompareFunc; Swap: TSwapFunc);

Procedure ExecuteApp(Path:String; Params:String='');
          { Spusti jinou aplikaci }

implementation

{*******************************
  CONVERSION UTILITIES
*******************************}

Function BoolToStr;
begin
 if X then Result:='A' else Result:='N';
end;

Function StrToBoolDef;
var S:String;
begin
 S:=UpperCase(Data);
 if S='ANO' then Result:=True else
 if S='NE' then Result:=False else
 if S='A' then Result:=True else
 if S='N' then Result:=False else
 if S='TRUE' then Result:=True else
 if S='FALSE' then Result:=False else
 if S='T' then Result:=True else
 if S='F' then Result:=False else
   Result:=ADef;
end;

Function ifThen(C,A,B:boolean):boolean;
begin
 if C then Result:=A else Result:=B;
end;

procedure QuickSort;
{ Quick sort }
var i,j,l,r,Aux:integer;

  procedure DoSort;
  var xi, xr: integer;
  begin
    i:=l; j:=r;
    Aux:=(l+r) div 2;
    repeat
      while (i<=r) and Compare(i, Aux) do inc(i);
      while (j>=l) and Compare(Aux, j) do dec(j);
      if i<=j then begin
	if i<>j then begin
	  Swap(i, j);
	  if i=Aux then Aux:=j else
	  if j=Aux then Aux:=i; 
	end;
	inc(i); dec(j); 
      end;
    until i>j;
    xi:=i; xr:=r;
    if l<j then begin
      r:=j;
      DoSort;
    end;
    if xi<xr then begin
      l:=xi;
      r:=xr;
      DoSort;
    end;
  end;

begin
 if Max>Min then begin
   l:=min; r:=max;
   DoSort;
 end;  
end;

Function CheckDec;
begin
 if DecimalSeparator=',' then
   while (pos('.',S)>0) do S[pos('.',S)]:=','
 else
   while (pos(',',S)>0) do S[pos(',',S)]:='.';
 Result:=S;
end;

Function SetDec;
begin
 while (pos(',',S)>0) do S[pos(',',S)]:='.';
 Result:=S;
end;

Function DelWS;
var i:integer;
begin
 Result:='';
 for i:=1 to Length(S) do begin
   if (S[i] in [#33..#127]) then Result:=Result+S[i];
 end;
end;

Procedure ExecuteApp;
begin
 ShellExecute(0,'open',PChar(Path),PChar(Params),Nil,SW_SHOWDEFAULT);
end;

end.
